local _,L = ...
local rematch = Rematch
local rematchsettings = RematchSettings
local old_PLAYER_TARGET_CHANGED = rematch.PLAYER_TARGET_CHANGED
local saved
local frame1
local frame2
local route = {}
myAllianceroute
myHorderoute
--format for route
--{
--[NPC ID for current target] = NPC ID for the next target
--}
--get the NPC IDs for trainers from, for example, NPCs.txt
local function getAllianceRoute()
	temp = {
		[87124] = 87123,
		[87123] = 87125,
		[87125] = 83837,
		[83837] = 87122,
		[87122] = 87110,
	}
	return temp
end
local function getHordeRoute()
	temp = {
		--Draenor
		[79858] = 87122,
		[87122] = 83837,
		[83837] = 87125,
		[87125] = 87123,
		[87123] = 87124,
		[87124] = 87110,
	}
	return temp
end
local function mergetables(prio1,prio2)
	local temp = {}
	for i, v in ipairs(prio2) do
		if not prio1[i] then
			prio1[i] = prio2[i]
		end
    end
	temp = prio1
	return temp
end
local function getRightRoute()
	local temp = {}
	local allianceroute = {} -- next target for alliance
	allianceroute = getAllianceRoute()
	local horderoute = {} -- next target for horde
	horderoute = getHordeRoute()
	if UnitFactionGroup("player") == "Horde" then temp = horderoute; temp = mergetables(myHorderoute,temp) end
	if UnitFactionGroup("player") == "Alliance" then temp = allianceroute;temp = mergetables(myAllianceroute,temp) end
	return temp
end

local function petbattleover(self,event,...)
	local key = rematchsettings.loadedTeam
	if key and saved[key] then
		if route[key] then
			print("Press Alt, and then select the trainer")
		else
			print("No next target defined!")
		end
	end	
end
local function addonloaded(self,event,arg1...)
	if arg1 == "Rematch Next Target" then
		if UnitFactionGroup("player") == "Horde" then temp = "horderoute"; end
		if UnitFactionGroup("player") == "Alliance" then temp = "allianceroute" end
		print(temp)
	end
end
local function playerlogout(self,event,...)
	if UnitFactionGroup("player") == "Horde" then myHorderoute = route end
	if UnitFactionGroup("player") == "Alliance" then myAllianceroute = route end
end
rematch:InitModule(function()
	saved = RematchSaved
	route = getRightRoute()
	frame1 = CreateFrame("Frame", "RematchNextTarget");
	frame1:SetScript("OnEvent", petbattleover);
	frame1:RegisterEvent("PET_BATTLE_OVER")
	frame2 = CreateFrame("FRAME","RematchNextTarget");
	frame2:SetScript("OnEvent", addonloaded);
	frame2:RegisterEvent("ADDON_LOADED");
	frame3 = CreateFrame("FRAME","RematchNextTarget");
	frame3:SetScript("OnEvent", playerlogout);
	frame3:RegisterEvent("PLAYER_LOGOUT");
end)
SLASH_RMTNXT = "/rmtnxt";
function SlashCmdList.RMTNXT(msg)
	if UnitFactionGroup("player") == "Horde" then temp = "horderoute"; end
	if UnitFactionGroup("player") == "Alliance" then temp = "allianceroute" end
	print("printing ",msg," ", temp);
end
local function my_PLAYER_TARGET_CHANGED(self)
	--local saved = RematchSaved
	local name,npcID = rematch:GetUnitNameandID("target")
	print (name, " ",npcID) -- code to check to verify the accuracy of the NPC ID - name of NPC table
	local namefromtable = rematch.notableNames [npcID]
	if namefromtable then
		if name ~= namefromtable then
			print (format("%s does not match %s",name,namefromtable))
		end
	end
	if route[npcID] then
		local key = route[npcID]
		if key then
			if saved[key] then
				local nxttrgt = rematch.notableNames[key]
				print(format("Loaded team for %s.",nxttrgt))
				rematch:LoadTeam(key)
			end
		end
	end
end
function Rematch:PLAYER_TARGET_CHANGED()
	if IsAltKeyDown() then
		local name,npcID = rematch:GetUnitNameandID("target")
		return my_PLAYER_TARGET_CHANGED(self)
	else
		if IsControlKeyDown() then
			local name,npcID = rematch:GetUnitNameandID("target")
			
		else
			return old_PLAYER_TARGET_CHANGED(self)
		end
	end
end

